#ifndef __SVLIB09_H
#define __SVLIB09_H

#ifndef __ASSOC_H
#include "assoc.h"
#endif

#ifndef __VELIB_H
#include "..\ve\velib.h"
#endif

#ifndef __TABUTIL_H
#include <tabutil.h>
#endif

#include "..\mg\mglib.h"

class TRWrecord_cache : public TRecord_cache
{
  TAssoc_array _flags;

protected:
  THash_object * get_some_obj();
  virtual const TString & getkey2discard();
public:
  virtual void discard(const TString & k);
  virtual void put(const TRectype &r);
  virtual const TRectype& get(const char* chiave);

  void clear();
  void flush();

  TRWrecord_cache(TLocalisamfile *f, int key = 1, bool lock=FALSE);
  TRWrecord_cache(int num, int key = 1, bool lock=FALSE);
  TRWrecord_cache(const char* table, int key = 1, bool lock=FALSE);
  virtual ~TRWrecord_cache() ;
  const TAssoc_array * internal_array() {return &_cache;}
};

#endif

